/*
 * (c) 2011 Siegen, Germany by Nils Faerber <nils.faerber@kernelconcepts.de>
 *
 * license LGPL
 */

#ifndef _METAWATCH_H
#define _METAWATCH_H

#include "metawatch_protocol.h"

void dump_frame(unsigned char *frame, int len);


int mw_send_frame(int mw_fd, unsigned char msg_type, unsigned char options, unsigned char *data, unsigned char len);

void mw_set_rtc(int mw_fd, unsigned char clk1224, unsigned char date_fmt);

void mw_set_vibrate_mode(int mw_fd, unsigned char enable, unsigned short on_time, unsigned short off_time, unsigned char cycles);

void mw_configure_watch_mode(int mw_fd, unsigned char mode, unsigned char save, unsigned char timeout, unsigned char invert);

void mw_update_display(int mw_fd, unsigned char mode, unsigned char copy);

void mw_load_template(int mw_fd, unsigned char mode, unsigned char template_select);

void mw_write_buffer(int mw_fd,
		unsigned char mode,
		unsigned char numlines,		/* number of lines, 0=two lines or 1=one line */
		unsigned char row_offset,	/* start at row_offset in display, e.g. lower part in idle @31 */
		unsigned char *buffer, int buflen);

void mw_write_oled_buffer(int mw_fd,
	unsigned char mode, /* idle or scroll */
	unsigned char oled, /* which OLED */
	unsigned char numcols,
	unsigned char col_index, /* starting index */
	unsigned char *buffer, int buflen);

void mw_get_real_time_clock_response(int mw_fd, unsigned char *rtcrsp, int len);

void mw_get_battery_voltage_response(int mw_fd, unsigned char *batrsp, int len);

void mw_status_change_event(int mw_fd, unsigned char option, unsigned char *statrsp, int len);

void mw_enable_button(int mw_fd, unsigned char mode, unsigned char button_index, unsigned char press_type, unsigned char callback_type, unsigned char callback_option);

void mw_disable_button(int mw_fd, unsigned char mode, unsigned char button_index, unsigned char press_type);

int decode_frame(int mw_fd, unsigned char *buf, int len);


void bmap_buffer_flipinvert(unsigned char flip, unsigned char invert, unsigned char *buf, int len);
void mw_send_bitmap(int mw_fd, unsigned char mode, int width, int height, int offset, unsigned char *bmapbuf, int buflen);

#endif /* _METAWATCH_H */

